package com.ruoyi.zhdd.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.PageUtils;
import com.ruoyi.common.core.page.PagePlus;
import com.ruoyi.common.core.page.TableDataInfo;
import org.springframework.stereotype.Service;
import com.ruoyi.common.core.mybatisplus.core.ServicePlusImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.ruoyi.zhdd.domain.bo.IncidentTaskPersonBo;
import com.ruoyi.zhdd.domain.vo.IncidentTaskPersonVo;
import com.ruoyi.zhdd.domain.IncidentTaskPerson;
import com.ruoyi.zhdd.mapper.IncidentTaskPersonMapper;
import com.ruoyi.zhdd.service.IIncidentTaskPersonService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 事件处置方案人员Service业务层处理
 *
 * @author xintong
 * @date 2021-11-27
 */
@Service
public class IncidentTaskPersonServiceImpl extends ServicePlusImpl<IncidentTaskPersonMapper, IncidentTaskPerson, IncidentTaskPersonVo> implements IIncidentTaskPersonService {

    @Override
    public IncidentTaskPersonVo queryById(String id){
        return getVoById(id);
    }

    @Override
    public TableDataInfo<IncidentTaskPersonVo> queryPageList(IncidentTaskPersonBo bo) {
        PagePlus<IncidentTaskPerson, IncidentTaskPersonVo> result = pageVo(PageUtils.buildPagePlus(), buildQueryWrapper(bo));
        return PageUtils.buildDataInfo(result);
    }

    @Override
    public List<IncidentTaskPersonVo> queryList(IncidentTaskPersonBo bo) {
        return listVo(buildQueryWrapper(bo));
    }

    private LambdaQueryWrapper<IncidentTaskPerson> buildQueryWrapper(IncidentTaskPersonBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<IncidentTaskPerson> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getIncidentTaskId()), IncidentTaskPerson::getIncidentTaskId, bo.getIncidentTaskId());
        lqw.eq(StringUtils.isNotBlank(bo.getPosition()), IncidentTaskPerson::getPosition, bo.getPosition());
        lqw.eq(StringUtils.isNotBlank(bo.getPerson()), IncidentTaskPerson::getPerson, bo.getPerson());
        return lqw;
    }

    @Override
    public Boolean insertByBo(IncidentTaskPersonBo bo) {
        IncidentTaskPerson add = BeanUtil.toBean(bo, IncidentTaskPerson.class);
        validEntityBeforeSave(add);
        return save(add);
    }

    @Override
    public Boolean updateByBo(IncidentTaskPersonBo bo) {
        IncidentTaskPerson update = BeanUtil.toBean(bo, IncidentTaskPerson.class);
        validEntityBeforeSave(update);
        return updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(IncidentTaskPerson entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<String> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return removeByIds(ids);
    }
}
